#include "support.h"

#define CLOCK 0x1c

hatval hat;
union REGS registers;
extern unsigned _heaplen = 1024;
extern unsigned _stklen = 1024;

void interrupt (*oldclock)(...);
void interrupt tmcool(...);

void main(int argc,char *argv[]) {
	FILE *config = NULL;

	if (argc < 2) {
		printf("A program to load must be provided.\r\n");
		printf("Please refer to the README.TXT file.\r\n");
		return;
	}

	config = fopen("TMLoader.cfg","rb");
	if (config == NULL) {
		printf("Unable to open configuration file.\r\n");
		return;
	}
	fread(&hat,sizeof(hatval),1,config);
	fclose(config);

	oldclock = getvect(CLOCK);
	setvect(CLOCK,tmcool);

	spawnv(P_WAIT,argv[1],&argv[1]);

	setvect(CLOCK,oldclock);
	return;
}

void interrupt tmcool(...) {
	static int coolie;
	int count,hold;
	char x;

	hold = 0;

	disable();
	outportb(0x201,0);
	for(count = 0; count < hat.max; count++) {
		x = inportb(0x201) & 8;
		if (x == 0) {
			hold = count;
			count = hat.max;
		}
	}
	enable();

	if (hold > (hat.center - hat.diff)) {
		if (coolie != hat.center) coolie = hat.center;
	} else if (hold < (hat.up + hat.diff)) {
		if (coolie != hat.up) {
			coolie = hat.up;
			registers.h.ah = 0x05;
			registers.h.ch = hat.uscan;
			registers.h.cl = hat.uchar;
			int86(0x16,&registers,&registers);
		}
	} else if (hold < (hat.right + hat.diff)) {
		if (coolie != hat.right) {
			coolie = hat.right;
			registers.h.ah = 0x05;
			registers.h.ch = hat.rscan;
			registers.h.cl = hat.rchar;
			int86(0x16,&registers,&registers);
		}
	} else if (hold < (hat.down + hat.diff)) {
		if (coolie != hat.down) {
			coolie = hat.down;
			registers.h.ah = 0x05;
			registers.h.ch = hat.dscan;
			registers.h.cl = hat.dchar;
			int86(0x16,&registers,&registers);
		}
	} else if (hold < (hat.left + hat.diff)) {
		if (coolie != hat.left) {
			coolie = hat.left;
			registers.h.ah = 0x05;
			registers.h.ch = hat.lscan;
			registers.h.cl = hat.lchar;
			int86(0x16,&registers,&registers);
		}
	}

	_chain_intr(oldclock);
}
